import { AfterViewInit, ElementRef, Injector, OnChanges, OnDestroy, OnInit, QueryList } from '@angular/core';
import { MediaObserver } from '@angular/flex-layout';
import { MatFormFieldAppearance } from '@angular/material/form-field';
import { MatPaginator } from '@angular/material/paginator';
import { MatSelectChange } from '@angular/material/select';
import { Subscription } from 'rxjs';
import { IGridItem } from '../../interfaces/o-grid-item.interface';
import { OGridComponentStateClass } from '../../services/state/o-grid-component-state.class';
import { OGridComponentStateService } from '../../services/state/o-grid-component-state.service';
import { OPermissions } from '../../types';
import { OGridPermissions } from '../../types/o-grid-permissions.type';
import { OQueryDataArgs } from '../../types/query-data-args.type';
import { SQLOrder } from '../../types/sql-order.type';
import { OFormComponent } from '../form/o-form.component';
import { AbstractOServiceComponent } from '../o-service-component.class';
import { OMatSort } from '../table/extensions/sort/o-mat-sort';
import { OGridItemComponent } from './grid-item/o-grid-item.component';
import { OGridItemDirective } from './grid-item/o-grid-item.directive';
import * as i0 from "@angular/core";
export declare const DEFAULT_INPUTS_O_GRID: string[];
export declare class OGridComponent extends AbstractOServiceComponent<OGridComponentStateService> implements AfterViewInit, OnChanges, OnDestroy, OnInit {
    protected _queryRows: number;
    fixedHeader: boolean;
    showPageSize: boolean;
    showSort: boolean;
    showFooter: boolean;
    gridItemHeight: string;
    refreshButton: boolean;
    insertButton: boolean;
    insertButtonFloatable: boolean;
    showButtonsText: boolean;
    insertButtonPosition: 'top' | 'bottom';
    paginationControls: boolean;
    gutterSize: string;
    protected _quickFilterAppearance: MatFormFieldAppearance;
    get cols(): number;
    set cols(value: number);
    get sortableColumns(): SQLOrder[];
    set sortableColumns(val: SQLOrder[]);
    quickFilterColumns: string;
    inputGridItems: QueryList<OGridItemComponent>;
    gridItemDirectives: QueryList<OGridItemDirective>;
    matpaginator: MatPaginator;
    protected _sortableColumns: SQLOrder[];
    sortColumnOrder: SQLOrder;
    protected _cols: any;
    protected _colsDefault: number;
    _pageSizeOptions: number[];
    protected sortColumn: string;
    storePaginationState: boolean;
    set gridItems(value: IGridItem[]);
    get gridItems(): IGridItem[];
    protected _gridItems: IGridItem[];
    protected subscription: Subscription;
    protected media: MediaObserver;
    protected oMatSort: OMatSort;
    protected permissions: OGridPermissions;
    protected actionsPermissions: OPermissions[];
    constructor(injector: Injector, elRef: ElementRef, form: OFormComponent);
    get state(): OGridComponentStateClass;
    ngOnInit(): void;
    initialize(): void;
    ngAfterViewInit(): void;
    ngAfterContentInit(): void;
    subscribeToMediaChanges(): void;
    reloadData(): void;
    reloadPaginatedDataFromStart(): void;
    protected getSortedDataFromArray(dataArray: any[]): any[];
    registerGridItemDirective(item: OGridItemDirective): void;
    onItemDetailClick(item: OGridItemDirective): void;
    onItemDetailDblClick(item: OGridItemDirective): void;
    ngOnDestroy(): void;
    destroy(): void;
    loadMore(): void;
    getQueryArguments(filter: object, ovrrArgs?: OQueryDataArgs): any[];
    parseSortColumn(): void;
    get currentOrderColumn(): number;
    set currentOrderColumn(val: number);
    protected findSortableColumnIndex(sortableColumn: SQLOrder): number;
    getDataToStore(): any;
    getSortOptionText(col: SQLOrder): string;
    add(): void;
    protected parseResponseArray(data: any[], replace?: boolean): any[];
    protected saveDataNavigationInLocalStorage(): void;
    protected setGridItemDirectivesData(): void;
    pageSizeChanged(): void;
    sortColumnChanged(event: MatSelectChange): void;
    registerQuickFilter(arg: any): void;
    protected getPaginationDataFromArray(dataArray: any[]): any[];
    static ɵfac: i0.ɵɵFactoryDeclaration<OGridComponent, [null, null, { optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<OGridComponent, "o-grid", never, { "cols": "cols"; "showPageSize": "show-page-size"; "showSort": "orderable"; "sortableColumns": "sortable-columns"; "sortColumn": "sort-column"; "quickFilterColumns": "quick-filter-columns"; "gridItemHeight": "grid-item-height"; "refreshButton": "refresh-button"; "gutterSize": "gutter-size"; "fixedHeader": "fixed-header"; "showFooter": "show-footer"; "insertButtonPosition": "insert-button-position"; "insertButtonFloatable": "insert-button-floatable"; "showButtonsText": "show-buttons-text"; }, {}, ["inputGridItems"], ["[o-grid-toolbar][position=start]", "[o-grid-toolbar][position=end]", "[o-grid-toolbar]"], false, never>;
}
