import { AfterViewInit, ElementRef, Injector, OnInit } from '@angular/core';
import { ValidatorFn } from '@angular/forms';
import { IIntegerPipeArgument, OIntegerPipe } from '../../../pipes/o-integer.pipe';
import { FormValueOptions } from '../../../types/form-value-options.type';
import { OFormComponent } from '../../form/o-form.component';
import { OFormDataComponent } from '../../o-form-data-component.class';
import * as i0 from "@angular/core";
type HTMLInputType = 'text' | 'number';
export declare const DEFAULT_INPUTS_O_INTEGER_INPUT: string[];
export declare class OIntegerInputComponent extends OFormDataComponent implements AfterViewInit, OnInit {
    inputType: HTMLInputType;
    min: number;
    max: number;
    step: number;
    protected grouping: boolean;
    protected thousandSeparator: string;
    protected olocale: string;
    protected componentPipe: OIntegerPipe;
    protected pipeArguments: IIntegerPipeArgument;
    constructor(form: OFormComponent, elRef: ElementRef, injector: Injector);
    initialize(): void;
    setComponentPipe(): void;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    setData(value: any): void;
    setValue(val: any, options?: FormValueOptions): void;
    innerOnFocus(event: FocusEvent): void;
    innerOnBlur(event?: any): void;
    setPipeValue(): void;
    isEmpty(): boolean;
    getInputEl(): any;
    setNumberDOMValue(val: any): void;
    setTextDOMValue(val: any): void;
    resolveValidators(): ValidatorFn[];
    protected initializeStep(): void;
    protected setInputTypeAndValue(inputType: HTMLInputType, value: any): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<OIntegerInputComponent, [{ optional: true; }, null, null]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<OIntegerInputComponent, "o-integer-input", never, { "min": "min"; "max": "max"; "step": "step"; "grouping": "grouping"; "thousandSeparator": "thousand-separator"; "olocale": "locale"; }, {}, never, never, false, never>;
}
export {};
