import { SelectionModel } from '@angular/cdk/collections';
import { FlatTreeControl } from '@angular/cdk/tree';
import { AfterViewInit, ElementRef, EventEmitter, Injector, OnDestroy, OnInit, TemplateRef } from '@angular/core';
import { Subscription } from 'rxjs';
import { OTreeComponentStateService } from '../../services/state/o-tree-component-state.service';
import { OPermissions } from '../../types';
import { OTreePermissions } from '../../types/o-tree-permissions.type';
import { OTreeFlatNode } from '../../types/tree-flat-node.type';
import { OFormComponent } from '../form/o-form.component';
import { AbstractOServiceComponent } from '../o-service-component.class';
import { OTreeDao } from './o-tree-dao.service';
import { OTreeDataSource } from './o-tree.datasource';
import { OTreeNodeComponent } from './tree-node/tree-node.component';
import * as i0 from "@angular/core";
export declare const DEFAULT_INPUTS_O_TREE: string[];
export declare const DEFAULT_OUTPUTS_O_TREE: string[];
export declare class OTreeComponent extends AbstractOServiceComponent<OTreeComponentStateService> implements OnInit, OnDestroy, AfterViewInit {
    injector: Injector;
    getLevel: (node: OTreeFlatNode) => number;
    isExpandable: (node: OTreeFlatNode) => boolean;
    getChildren: (node: OTreeFlatNode) => any;
    getTreeNodeChildren(node: OTreeFlatNode): any;
    getRecursiveChildrenNode(node: OTreeFlatNode): any;
    getComponentFilter(existingFilter?: any): any;
    hasChild: (_: number, _nodeData: OTreeFlatNode) => boolean;
    hasNoContent: (_: number, _nodeData: OTreeFlatNode) => boolean;
    dataSource: OTreeDataSource;
    refreshButton: boolean;
    deleteButton: boolean;
    showButtonsText: boolean;
    visibleColumns: string;
    separator: string;
    parentColumn: string;
    sortColumn: string;
    selectAllCheckboxVisible: boolean;
    selectAllCheckbox: boolean;
    recursive: boolean;
    protected _quickFilter: boolean;
    paginationControls: boolean;
    quickFilterColumns: string;
    selectedNode: OTreeFlatNode;
    childreNodes: OTreeFlatNode[];
    nodesArray: OTreeFlatNode[];
    ancestors: any[];
    checklistSelection: SelectionModel<OTreeFlatNode>;
    onNodeSelected: EventEmitter<any>;
    onNodeExpanded: EventEmitter<any>;
    onNodeCollapsed: EventEmitter<any>;
    onLoadNextLevel: EventEmitter<any>;
    onNodeClick: EventEmitter<any>;
    rootTitle: string;
    rootNodes: OTreeFlatNode[];
    daoTree: OTreeDao;
    leafNodeTemplate: TemplateRef<any>;
    parentNodeTemplate: TemplateRef<any>;
    treeFlattener: any;
    treeControl: FlatTreeControl<OTreeFlatNode, OTreeFlatNode>;
    set nodeTemplate(value: TemplateRef<any>);
    treeNode: OTreeNodeComponent;
    protected permissions: OTreePermissions;
    protected actionsPermissions: OPermissions[];
    protected visibleColumnsArray: string[];
    enabledDeleteButton: boolean;
    protected subscription: Subscription;
    route: string;
    get showTreeMenuButton(): boolean;
    constructor(injector: Injector, elRef: ElementRef, form: OFormComponent);
    ngOnInit(): void;
    initialize(): void;
    protected initializeDao(): void;
    initializeParams(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    registerTreeNode(oTreeNode: OTreeNodeComponent): void;
    checkboxClicked(event: Event): void;
    leafNodeClicked(event: Event, node: OTreeFlatNode): void;
    parentNodeClicked(event: Event, node: OTreeFlatNode): void;
    protected nodeClicked(node: OTreeFlatNode, event: Event): void;
    isRootNode(node: OTreeFlatNode): boolean;
    onClickToggleButton(event: Event, node: any): void;
    toggleNode(node: OTreeFlatNode, expand: boolean): void;
    private updateAsyncTree;
    todoLeafItemSelectionToggle(node: OTreeFlatNode): void;
    todoItemSelectionToggle(node: OTreeFlatNode): void;
    descendantsAllSelected(node: OTreeFlatNode): boolean;
    descendantsPartiallySelected(node: OTreeFlatNode): boolean;
    protected setTreeControl(): void;
    protected setDatasource(): void;
    getParentNodes(node: OTreeFlatNode, index: number, tree: OTreeFlatNode[]): OTreeFlatNode[];
    filterData(value?: string, loadMore?: boolean): void;
    expandNodesWithNodes(treeData: OTreeFlatNode[]): void;
    getDataArray(): any[];
    setDataArray(data: any): void;
    transformer: (node: any, level: number, parentNode?: any) => OTreeFlatNode;
    onSelectCheckboxChange(visible: boolean): void;
    protected sort(array: OTreeFlatNode[]): void;
    protected getItemText(item: any): string;
    getItemKey(item: any): string;
    protected filterByQuickFilterColumns(item: any, quickfilter: string): boolean;
    add(e?: Event): void;
    protected getNodeId(item: any, parentNode: any): string;
    protected navigateToViewDetail(node: OTreeFlatNode): void;
    isSelectedNode(node: OTreeFlatNode): boolean;
    onItemDetailClick(node: OTreeFlatNode): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<OTreeComponent, [null, null, { optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<OTreeComponent, "o-tree", never, { "oattr": "attr"; "service": "service"; "entity": "entity"; "columns": "columns"; "keys": "keys"; "parentKeys": "parent-keys"; "queryMethod": "query-method"; "insertButton": "insert-button"; "refreshButton": "refresh-button"; "deleteButton": "delete-button"; "visibleColumns": "visible-columns"; "selectAllCheckbox": "select-all-checkbox"; "separator": "separator"; "parentColumn": "parent-column"; "sortColumn": "sort-column"; "selectAllCheckboxVisible": "select-all-checkbox-visible"; "filterCaseSensitive": "filter-case-sensitive"; "quickFilter": "quick-filter"; "quickFilterPlaceholder": "quick-filter-placeholder"; "quickFilterColumns": "quick-filter-columns"; "detailMode": "detail-mode"; "detailFormRoute": "detail-form-route"; "showButtonsText": "show-buttons-text"; "rootTitle": "root-title"; "recursive": "recursive"; "route": "route"; }, { "onNodeSelected": "onNodeSelected"; "onNodeExpanded": "onNodeExpanded"; "onNodeCollapsed": "onNodeCollapsed"; "onLoadNextLevel": "onLoadNextLevel"; "onDataLoaded": "onDataLoaded"; "onNodeClick": "onNodeClick"; }, ["leafNodeTemplate", "parentNodeTemplate", "nodeTemplate", "treeNode"], ["[o-tree-button]"], false, never>;
}
