import { AfterViewInit, EventEmitter } from '@angular/core';
import { ThemePalette } from '@angular/material/core';
import { OAppHeaderBase } from '../../components/app-header/o-app-header-base.class';
import { OAppSidenavBase } from '../../components/app-sidenav/o-app-sidenav-base.class';
import { OUserInfoConfigurationDirective } from '../../components/user-info/user-info-configuration/o-user-info-configuration.directive';
import { OAppLayoutMode, OSidenavMode } from '../../util/codes';
import * as i0 from "@angular/core";
export declare const DEFAULT_INPUTS_O_APP_LAYOUT: string[];
export declare const DEFAULT_OUTPUTS_O_APP_LAYOUT: any[];
export declare class OAppLayoutComponent implements AfterViewInit {
    sidenavOpened: boolean;
    showUserInfo: boolean;
    showLanguageSelector: boolean;
    useFlagIcons: boolean;
    protected _showHeader: boolean;
    showTitle: boolean;
    staticTitle: string;
    showStaticTitle: boolean;
    showEllipsisMenu: boolean;
    headerColor: ThemePalette;
    headerHeight: string;
    appSidenav: OAppSidenavBase;
    appHeader: OAppHeaderBase;
    userInfoConfiguration: OUserInfoConfigurationDirective;
    protected _mode: OAppLayoutMode;
    protected _sidenavMode: OSidenavMode;
    openedSidenavImg: string;
    closedSidenavImg: string;
    beforeOpenSidenav: EventEmitter<boolean>;
    afterOpenSidenav: EventEmitter<boolean>;
    beforeCloseSidenav: EventEmitter<boolean>;
    afterCloseSidenav: EventEmitter<boolean>;
    private _tooltipDisplayMode;
    get showHeader(): boolean;
    set showHeader(val: boolean);
    get mode(): OAppLayoutMode;
    set mode(val: OAppLayoutMode);
    get sidenavMode(): OSidenavMode;
    set sidenavMode(val: OSidenavMode);
    get tooltipDisplayMode(): string;
    set tooltipDisplayMode(val: string);
    sidenavToggle(opened: boolean): void;
    afterToggle(opened: boolean): void;
    ngAfterViewInit(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<OAppLayoutComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<OAppLayoutComponent, "o-app-layout", never, { "mode": "mode"; "sidenavMode": "sidenav-mode"; "sidenavOpened": "sidenav-opened"; "_showHeader": "show-header"; "showUserInfo": "show-user-info"; "showLanguageSelector": "show-language-selector"; "useFlagIcons": "use-flag-icons"; "openedSidenavImg": "opened-sidenav-image"; "closedSidenavImg": "closed-sidenav-image"; "headerColor": "header-color"; "headerHeight": "header-height"; "showTitle": "show-title"; "staticTitle": "static-title"; "showStaticTitle": "show-static-title"; "tooltipDisplayMode": "tooltip-display-mode"; "showEllipsisMenu": "show-ellipsis-menu"; }, { "beforeOpenSidenav": "beforeOpenSidenav"; "afterOpenSidenav": "afterOpenSidenav"; "beforeCloseSidenav": "beforeCloseSidenav"; "afterCloseSidenav": "afterCloseSidenav"; }, ["userInfoConfiguration"], ["o-app-layout-sidenav[position=start]", "o-app-layout-sidenav[position=end]", "o-app-layout-sidenav", "o-app-layout-header[position=start]", "o-app-layout-header[position=end]", "o-app-layout-header", "*"], false, never>;
}
