export type OAppLayoutMode = 'mobile' | 'desktop';
export type OSidenavMode = 'over' | 'push' | 'side';
export type CHANGE_EVENTS = 'onValueChange' | 'onChange';
export type ORowHeight = 'small' | 'medium' | 'large';
export type OTableEditionMode = 'none' | 'click' | 'dblclick' | 'doubleclick';
export type OTableDetailMode = 'none' | 'click' | 'dblclick' | 'doubleclick';
export type OTooltipDisplayMode = 'always' | 'never' | 'only-collapsed' | 'only-expanded';
export declare class Codes {
    static PAGINATED_QUERY_METHOD: string;
    static DELETE_METHOD: string;
    static INSERT_METHOD: string;
    static UPDATE_METHOD: string;
    static QUERY_METHOD: string;
    static DEFAULT_QUERY_ROWS: number;
    static PAGE_SIZE_OPTIONS: number[];
    static DETAIL_ICON: string;
    static EDIT_ICON: string;
    static DEFAULT_ROW_HEIGHT: string;
    static readonly AVAILABLE_ROW_HEIGHTS_VALUES: string[];
    static DETAIL_MODE_NONE: string;
    static DETAIL_MODE_CLICK: string;
    static DETAIL_MODE_DBLCLICK_VALUES: string[];
    static readonly AVAILABLE_DETAIL_MODES: string[];
    static EDITION_MODE_NONE: string;
    static EDITION_MODE_CLICK: string;
    static EDITION_MODE_DBLCLICK_VALUES: string[];
    static readonly AVAILABLE_MODES: string[];
    static SELECTION_MODE_NONE: string;
    static SELECTION_MODE_SINGLE: string;
    static SELECTION_MODE_MULTIPLE: string;
    static EXPORT_MODE_VISIBLE: string;
    static EXPORT_MODE_LOCAL: string;
    static EXPORT_MODE_ALL: string;
    static HYPHEN_SEPARATOR: string;
    static SPACE_SEPARATOR: string;
    static COLUMNS_ALIAS_SEPARATOR: string;
    static ARRAY_INPUT_SEPARATOR: string;
    static TYPE_SEPARATOR: string;
    static VALUES_SEPARATOR: string;
    static ASC_SORT: string;
    static DESC_SORT: string;
    static TYPE_INT: string;
    static ROUTE_SEPARATOR: string;
    static ROUTE_VARIABLE_CHAR: string;
    static PARENT_KEYS_KEY: string;
    static QUERY_PARAMS: string;
    static IS_DETAIL: string;
    static LANGUAGE_KEY: string;
    static SESSION_KEY: string;
    static SESSION_EXPIRED_KEY: string;
    static LOGIN_ROUTE: string;
    static FORBIDDEN_ROUTE: string;
    static DEFAULT_EDIT_ROUTE: string;
    static DEFAULT_DETAIL_ROUTE: any;
    static DEFAULT_INSERT_ROUTE: string;
    static IGNORE_CAN_DEACTIVATE: string;
    static INSERTION_MODE: string;
    static ONTIMIZE_SUCCESSFUL_CODE: number;
    static ONTIMIZE_FAILED_CODE: number;
    static ONTIMIZE_UNAUTHORIZED_CODE: number;
    static ICON_POSITION_LEFT: string;
    static ICON_POSITION_RIGHT: string;
    static COLUMN_TITLE_ALIGN_START: string;
    static COLUMN_TITLE_ALIGN_CENTER: string;
    static COLUMN_TITLE_ALIGN_END: string;
    static COLUMN_TITLE_ALIGN_AUTO: string;
    static AVAILABLE_COLUMN_TITLE_ALIGNS: string[];
    static O_MAT_ERROR_STANDARD: string;
    static O_MAT_ERROR_LITE: string;
    static O_INPUTS_OPTIONS_COLOR_ACCENT: string;
    static HourFormat: {
        TWELVE: string;
        TWENTY_FOUR: string;
    };
    static CLOSE_DETAIL_ACTION: string;
    static BACK_ACTION: string;
    static RELOAD_ACTION: string;
    static GO_EDIT_ACTION: string;
    static EDIT_ACTION: string;
    static INSERT_ACTION: string;
    static GO_INSERT_ACTION: string;
    static DELETE_ACTION: string;
    static UNDO_LAST_CHANGE_ACTION: string;
    static DEFAULT_COLUMN_MIN_WIDTH: number;
    static NAME_COLUMN_SELECT: string;
    static NAME_COLUMN_EXPANDABLE: string;
    static SUFFIX_COLUMN_INSERTABLE: string;
    static LIMIT_SCROLLVIRTUAL: number;
    static TWENTY_FOUR_HOUR_FORMAT: number;
    static TWELVE_FOUR_HOUR_FORMAT: number;
    static OAppLayoutModes: OAppLayoutMode[];
    static OSidenavModes: OSidenavMode[];
    static OAppLayoutMode: string[];
    static OSidenavMode: string[];
    static APP_LAYOUT_MODE_DESKTOP: OAppLayoutMode;
    static APP_LAYOUT_MODE_MOBILE: OAppLayoutMode;
    static VISIBLE_EXPORT_BUTTONS: string[];
    static VISIBLE_EXPORT_BUTTONS3X: string[];
    static DEFAULT_CHANGE_EVENT: CHANGE_EVENTS;
    static TYPES_DATE_GROUPS: string[];
    static readonly TOOLTIP_DISPLAY_MODE: string[];
    static readonly TOOLTIP_DISPLAY_COLLAPSED = "only-collapsed";
    static isDoubleClickMode(value: string): boolean;
    static isValidRowHeight(value: string): boolean;
    static getIsDetailObject(): any;
    static formatString(format: number): string;
    static isHourInputAllowed(e: KeyboardEvent): boolean;
    static isValidEditionMode(editionMode: OTableEditionMode): boolean;
    static isValidDetailMode(detailMode: OTableDetailMode): any;
}
